from datetime import datetime

from app.events.base_event import BaseEvent
from app.storage.persistent_event import PersistentEvent

class PrintJobAddedEvent(BaseEvent):
    def __init__(self, *, uuid: str, created_at: datetime, **kwargs) -> None:
        super().__init__(uuid=uuid, **kwargs)
        self.timestamp = created_at

    @classmethod
    def from_persistent_event(cls, event: PersistentEvent) -> "BaseEvent":
        props = event.props if event.props is not None else {}
        return cls(uuid=event.entity_uuid, created_at=event.timestamp, **props)
