from app.events.base_event import BaseEvent
from app.storage.persistent_event import PersistentEvent


class PrintJobMovedEvent(BaseEvent):
    def __init__(self, *, uuid: str, to_position: int, **kwargs) -> None:
        super().__init__(uuid=uuid, to_position=to_position, **kwargs)

    @classmethod
    def from_persistent_event(cls, event: PersistentEvent) -> "BaseEvent":
        data = event.props
        try:
            del(data["uuid"])
        except KeyError:
            pass
        return cls(uuid=event.entity_uuid, **data)
