from .g_code_parser import GCodeParser
from .gzip_gcode_parser import GzipGCodeParser
from typing import Optional


def createGCodeParser(file_path: str) -> Optional[GCodeParser]:
    extension_bits = file_path.lower().split(".")
    extension = extension_bits[-1]
    if extension == "gz":
        extension = extension_bits[-2] + ".gz"

    for parser_class in (GCodeParser, GzipGCodeParser):
        if extension in parser_class.get_supported_file_types():
            return parser_class(file_path)

    return None
