from requests.models import Response
from requests import RequestException


class PrinterApiException(Exception):
    def __init__(self, message: str="") -> None:
        super().__init__(message)


class PrinterApiHttpException(PrinterApiException):
    def __init__(self, response: Response, message: str="") -> None:
        super().__init__(message)
        self._response = response

    def get_response(self) -> Response:
        return self._response


class PrinterApiNetworkException(PrinterApiException):
    def __init__(self, request_exception: RequestException, message: str="") -> None:
        super().__init__(message)
        self._request_exception = request_exception

    def get_request_exception(self) -> RequestException:
        return self._request_exception
