from typing import List, Dict, Any

from app.libs.ultimaker3.extruder import Extruder


class PrintHead:
    def __init__(self, data: Dict[str, Any]) -> None:
        self.extruders = self.__parse_extruders(data["extruders"])

    @staticmethod
    def __parse_extruders(extruders_data: List[Dict[str, Any]]) -> List[Extruder]:
        return list(map(Extruder, extruders_data))
