from typing import List, Dict, Any

from app.libs.ultimaker3.build_plate import BuildPlate
from app.libs.ultimaker3.printhead import PrintHead


class Status:
    def __init__(self, data: Dict[str, Any]) -> None:
        self.status = data["status"]    # type: str
        self.heads = self.__parse_heads(data["heads"])
        self.build_plate = BuildPlate(data["bed"])

    @staticmethod
    def __parse_heads(heads_data: List[Dict[str, Any]]) -> List[PrintHead]:
        return list(map(PrintHead, heads_data))

    def __str__(self) -> str:
        return "Status(%s)" % self.status
