from typing import Any, Dict, Optional
from datetime import datetime

class System:
    def __init__(self, data: Dict[str, Any]) -> None:
        self.name = data["name"]                    # type: str
        self.hostname = data["hostname"]            # type: str
        self.machine_variant = data["variant"]      # type: str
        self.time = None                            # type: Optional[datetime]
        self.language = data["language"]            # type: str
        self.firmware_version = data["firmware"]    # type: str
        self.uptime = data["uptime"]                # type: int

        if "time" in data and "utc" in data["time"]:
            try:
                self.time = datetime.utcfromtimestamp(float(data["time"]["utc"]))
            except ValueError:
                pass
