from typing import Any, Optional
from app.libs.ultimaker3.material import Material


class ExtruderTrain:
    def __init__(self,
                 *,
                 extruder_index: int,
                 material_guid: str,
                 nozzle_diameter: str,
                 print_core_id: str=None,
                 material: Material=None) -> None:

        self.extruder_index = extruder_index
        self.material_guid = material_guid
        self.nozzle_diameter = nozzle_diameter
        self.print_core_id = print_core_id
        self.material = material    # type: Optional[Material]

    def __eq__(self, other: Any) -> bool:
        if isinstance(other, ExtruderTrain):
            return self.extruder_index == other.extruder_index \
                   and self.material_guid == other.material_guid \
                   and self.nozzle_diameter == other.nozzle_diameter \
                   and self.print_core_id == other.print_core_id

        return False

    def __repr__(self) -> str:
        return "ExtruderTrain(extruder_index=%s, material_guid=%s, nozzle_diameter=%s, print_core_id=%s)" \
               % (self.extruder_index, self.material_guid, self.nozzle_diameter, self.print_core_id)
