from typing import Any


class LedColor:
    def __init__(self, *, hue: int, saturation: float, value: float) -> None:
        self.hue = hue
        self.saturation = saturation
        self.value = value

    def __eq__(self, other: Any) -> bool:
        if isinstance(other, LedColor):
            return self.hue == other.hue \
                   and self.saturation == other.saturation \
                   and self.value == other.value
        return False

    def __str__(self) -> str:
        return "LedColor(h=%s s=%s v=%s)" % (self.hue, self.saturation, self.value)
