import logging
from typing import List

from app.models.abstraction.abstract_collection_model import AbstractCollectionModel
from app.models.printer import Printer

logger = logging.getLogger(__name__)


class PrinterCollection(AbstractCollectionModel[Printer]):
    def __init__(self) -> None:
        super().__init__()
        self.onDelete.connect(lambda printer: logger.info("Removed printer[%s]", printer))
        self.onAdd.connect(lambda printer: logger.info("Added printer[%s]", printer))

    def all(self) -> List[Printer]:
        return list(sorted(self.data.values(), key=lambda printer: printer.friendly_name))
