from app.models.print_job import PrintJob
from app.models.printer import Printer
from app.services.scheduler.match_rule import MatchRule, Optional
from app.services.scheduler.result_containers.match_results import FutureMatchResult, MatchResult


class IsPrinterDisabledMatchRule(MatchRule):
    def apply(self, printer: Printer, print_job: PrintJob) -> Optional[MatchResult]:
        if not printer.enabled:
            return FutureMatchResult(
                time=float("inf"),
                origin=self,
                debug_message="Printer is disabled",
                translation_key="printer_is_disabled"
            )
        return None
