from app.constants.printer_status import PrinterStatus
from app.models.print_job import PrintJob
from app.models.printer import Printer
from app.services.scheduler.match_rule import MatchRule, Optional
from app.services.scheduler.result_containers.match_results import FutureMatchResult, MatchResult


class IsPrinterPrintingMatchRule(MatchRule):
    def apply(self, printer: Printer, print_job: PrintJob) -> Optional[MatchResult]:
        if printer.status == PrinterStatus.PRINTING:
            return FutureMatchResult(
                time=printer.time_remaining,
                origin=self,
                debug_message="Printer is printing",
                translation_key="printer_is_printing"
            )
        return None
