from app.events.print_job_added_event import PrintJobAddedEvent
from app.events.print_job_deleted import PrintJobDeletedEvent
from app.events.print_job_moved_event import PrintJobMovedEvent
from app.events.print_job_started_event import PrintJobStartedEvent
from app.events.print_job_updated_event import PrintJobUpdatedEvent
from app.libs.signal import Signal
from app.models.print_job import PrintJob
from app.models.print_job_collection import PrintJobCollection
from app.storage.event_store import EventStore
from .abstract_event_storage_manager import AbstractEventStorageManager


class PrintJobEventStorageManager(AbstractEventStorageManager[PrintJob]):
    def __init__(self, event_store: EventStore, replay_done: Signal, collection: PrintJobCollection) -> None:
        super().__init__(
            event_store=event_store,
            replay_done=replay_done,
            collection=collection,
            add_event=PrintJobAddedEvent,
            modify_events=[PrintJobUpdatedEvent, PrintJobStartedEvent],
            move_event=PrintJobMovedEvent,
            delete_event=PrintJobDeletedEvent,
            model=PrintJob
        )
