# Database of AVR chips for avr_isp programming. Contains signatures and flash sizes from the AVR datasheets.
# To support more chips add the relevant data to the avrChipDB list.
# This is a python 3 conversion of the code created by David Braam for the Cura project.
import os
import json
import binascii

## Get the chip information from a signature bytes object.
#  @return the specific chip data, or None if the chip is not found.
def get(signature):
    signature_string = binascii.hexlify(signature).lower().decode('utf-8')
    data = json.load(open(os.path.join(os.path.dirname(__file__), "chipDB.json"), "r"))
    for chip_name, chip_data in data.items():
        if chip_data["signature"].lower() == signature_string:
            chip_data['name'] = chip_name
            return chip_data
    return None

if __name__ == "__main__":
    print(get(bytes([0x1E,0x97,0x03])))
