from griffin.interface.http.exposedItems.httpExposedObject import HttpExposedObject
from griffin.interface.http.flaskResponses import FlaskResponses

from urllib.parse import urlparse
import flask
from griffin import dbusif

from urllib import parse

import logging
log = logging.getLogger(__name__.split(".")[-1])


# Materials is a special case of an HttpExposedObject.
class Camera(HttpExposedObject):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, allowed_request_methods=["GET", "POST"], **kwargs)
        self.__camera_service = dbusif.RemoteObject("camera")

    def register(self):
        super().register()
        self._server.add_url_rule(self.getAbsolutePath() + "/<index>/stream", view_func=self.redirectToStream, methods=["GET"])
        self._server.add_url_rule(self.getAbsolutePath() + "/<index>/snapshot", view_func=self.redirectToSnapshot, methods=["GET"])

    def redirectToStream(self, index):
        try:
            camera_info = self.__camera_service.getCameras()[int(index)]
        except (KeyError, ValueError):
            return FlaskResponses.createNotFound("Camera index not found")
        return flask.redirect(camera_info["stream"].format(host=urlparse(flask.request.url).hostname))

    def redirectToSnapshot(self, index):
        try:
            camera_info = self.__camera_service.getCameras()[int(index)]
        except (KeyError, ValueError):
            return FlaskResponses.createNotFound("Camera index not found")
        return flask.redirect(camera_info["snapshot"].format(host=urlparse(flask.request.url).hostname))
