from . import abstractHardware
import logging

log = logging.getLogger(__name__.split(".")[-1])


## This class does not control any hardware, but can be used in place of the normal hardware class.
#  This allows a controller to exist without any underlay hardware implementation.
class DummyHardware(abstractHardware.AbstractHardware):
    def __init__(self):
        super().__init__()

    ## Set the leds to a fixed color.
    #  This needs to be implemented by every subclass.
    #  @param red: float - Red output in range 0.0 to 1.0
    #  @param green: float - Green output in range 0.0 to 1.0
    #  @param blue: float - Blue output in range 0.0 to 1.0
    def setRGB(self, red, green, blue):
        pass
