from . import hsvColor

## Immutable version of the HsvColor, used for static colors.
#  This subclass prevents the colors from being modified.
class ImmutableHsvColor(hsvColor.HsvColor):
    @hsvColor.HsvColor.hue.setter
    def hue(self, new_value):
        raise NotImplementedError("Not allowed to change static color values")

    @hsvColor.HsvColor.saturation.setter
    def saturation(self, new_value):
        raise NotImplementedError("Not allowed to change static color values")

    @hsvColor.HsvColor.value.setter
    def value(self, new_value):
        raise NotImplementedError("Not allowed to change static color values")
