from griffin.printer.procedures.procedureStep import ProcedureStep
from griffin import signal

import time


## @brief Simple step that runs forever and wait for messages which indicate a selection for a printcore profile
class WaitForHotendProfileStep(ProcedureStep):

    ## @brief The sleep timeout for the step (doesn't matter much) in seconds
    __SHORT_DELAY = 0.5

    def __init__(self, key):
        super().__init__(key)
        self.stepDataReady = signal.Signal()

    def run(self):
        while not self._abort:
            time.sleep(self.__SHORT_DELAY)

    def receiveMessage(self, message):
        if message != "ABORT":
            self.__hotend_profile = message
            self.stepDataReady.emit(message)

