import logging
from griffin.printer.procedures.procedureStep import ProcedureStep
from griffin.datatypes import eventType

log = logging.getLogger(__name__.split(".")[-1])


## A step to post an event to the event log.
class PostEventToLogStep(ProcedureStep):
    # @param step_key: The name of this step.
    # @param event_type: An eventType.EventType instance, from the eventType module.
    # @param parameters: An optional list of parameters stored with this event. Is allowed to be None
    def __init__(self, step_key, event_type, parameters=None):
        super().__init__(step_key)

        assert isinstance(event_type, eventType.EventType)

        self.__event_type = event_type
        self.__parameters = parameters or []

    # Post the event to the log, and directly finish.
    def run(self):
        eventType.postEvent(self.__event_type, self.__parameters)
