from griffin.printer.procedures.procedureStep import ProcedureStep
from griffin.printer.controller import Controller
from griffin.thread import Event
import logging

log = logging.getLogger(__name__.split(".")[-1])

## This class receives and stores the nr of print cores selected in the value_store
class SelectCleaningMaterialStep(ProcedureStep):
    def __init__(self, key, value_store):
        super().__init__(key)
        self.__value_store = value_store
        self.__message_received_event = Event()

    def run(self):
        self.__message_received_event.clear()
        Controller.getInstance().setPropertyValue("interaction_required", True)

        while not self.__message_received_event.is_set() and not self._abort:
            self.__message_received_event.wait(self.TIME_OUT_WAIT_FINISHED_EVENT)

        Controller.getInstance().setPropertyValue("interaction_required", False)

    def receiveMessage(self, message):
        log.info("Message: %s", message)

        if str(message) in ("MATERIAL_PC", "MATERIAL_PLA"):
            self.__value_store.append(str(message))
            self.__message_received_event.set()
